! ---------------------------------------------------
!   Solve for the roots of  Ax^2 + Bx + C = 0 
! ---------------------------------------------------

PROGRAM  quadmain
   IMPLICIT  NONE

   REAL  :: a, b, c
   REAL  :: q1, q2
   LOGICAL :: is_complex

!  read in the coefficients a, b and c

   READ(*,*)  a, b, c
   WRITE(*,*) 'a = ', a
   WRITE(*,*) 'b = ', b
   WRITE(*,*) 'c = ', c
   WRITE(*,*)

!  CALL the subroutine to compute the roots
   CALL quad_roots(a, b, c, q1, q2, is_complex)

   IF (.NOT.is_complex) THEN             
      WRITE(*,*)  'Roots are ', q1, ' and ', q2
   ELSE                           
      WRITE(*,*)  'The roots are complex'
   END IF


END PROGRAM  quadmain

SUBROUTINE quad_roots(a, b, c, q1, q2, is_complex)
IMPLICIT NONE
REAL, INTENT(IN) :: a, b, c
REAL, INTENT(OUT) :: q1, q2
LOGICAL, INTENT(OUT) :: is_complex
REAL :: d

   d = b*b - 4.0*a*c
   IF (d >= 0.0) THEN              ! is it solvable?
      d     = SQRT(d)
      q1 = (-b + d)/(2.0*a)     ! first root
      q2 = (-b - d)/(2.0*a)     ! second root
      is_complex =.FALSE.
   ELSE                            ! complex roots
      is_complex =.TRUE.
   END IF

END SUBROUTINE        
   
